// -*- mode: C++ -*-

// AUTOGENERATED BY glean_parser.  DO NOT EDIT.

/* This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at http://mozilla.org/MPL/2.0/. */

#ifndef mozilla_GleanDomMediaMetrics_h
#define mozilla_GleanDomMediaMetrics_h

#include "mozilla/glean/bindings/MetricTypes.h"

namespace mozilla::glean {

namespace gmp {
  /**
   * generated from gmp.update_xml_fetch_result
   */
  enum class UpdateXmlFetchResultLabel: uint16_t {
    eCertPinSuccess = 0,
    eCertPinNetRequestError = 1,
    eCertPinNetTimeout = 2,
    eCertPinAbort = 3,
    eCertPinMissingData = 4,
    eCertPinFailed = 5,
    eCertPinInvalid = 6,
    eCertPinXmlParseError = 7,
    eCertPinUnknownError = 8,
    eContentSigSuccess = 9,
    eContentSigNetRequestError = 10,
    eContentSigNetTimeout = 11,
    eContentSigAbort = 12,
    eContentSigMissingData = 13,
    eContentSigFailed = 14,
    eContentSigInvalid = 15,
    eContentSigXmlParseError = 16,
    eContentSigUnknownError = 17,
    e__Other__,
  };
  /**
   * The result of Gecko fetching an update.xml from Balrog. This captures 3 different data points: success or failure of the request, if cert pinning or content signatures were used to verify the result, and the reason for failure, if the request failed.
   */
  constexpr impl::Labeled<impl::CounterMetric, UpdateXmlFetchResultLabel> update_xml_fetch_result(3464);
}

namespace media {
  /**
   * generated from media.element_in_page_count
   * The number of times a document hierarchy contained at least one HTMLMediaElement. In addition, the telemetry probe 'MIXED_CONTENT_UNBLOCK_COUNTER' records the total number of loaded top level content documents, which can help us calculate the result of the percentage of documents using media. This metric was generated to correspond to the Legacy Telemetry scalar media.element_in_page_count.
   */
  constexpr impl::CounterMetric element_in_page_count(3465);

  /**
   * generated from media.error
   */
  struct ErrorExtra {
    mozilla::Maybe<nsCString> errorName;
    mozilla::Maybe<nsCString> errorType;
    mozilla::Maybe<nsCString> keySystem;

    std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
      nsTArray<nsCString> extraKeys;
      nsTArray<nsCString> extraValues;
      if (errorName) {
        extraKeys.AppendElement()->AssignASCII("error_name");
        extraValues.EmplaceBack(errorName.value());
      }
      if (errorType) {
        extraKeys.AppendElement()->AssignASCII("error_type");
        extraValues.EmplaceBack(errorType.value());
      }
      if (keySystem) {
        extraKeys.AppendElement()->AssignASCII("key_system");
        extraValues.EmplaceBack(keySystem.value());
      }
      return std::make_tuple(std::move(extraKeys), std::move(extraValues));
    }
  };
  /**
   * Record the error details happened on a media element.
   */
  constexpr impl::EventMetric<ErrorExtra> error(3466);

  /**
   * generated from media.video_hardware_decoding_support
   * Record whether hardware decoding is supported for the specific video codec. The key is the type of video codec, eg. video/vp9. This metric was generated to correspond to the Legacy Telemetry scalar media.video_hardware_decoding_support.
   */
  constexpr impl::Labeled<impl::BooleanMetric, DynamicLabel> video_hardware_decoding_support(3467);

  /**
   * generated from media.video_hd_hardware_decoding_support
   * Record whether hardware decoding is supported for the specific video codec, this only records video in HD (1280*720) or higher resultion. The key is the type of video codec, eg. video/vp9. This metric was generated to correspond to the Legacy Telemetry scalar media.video_hd_hardware_decoding_support.
   */
  constexpr impl::Labeled<impl::BooleanMetric, DynamicLabel> video_hd_hardware_decoding_support(3468);
}

namespace media_audio {
  /**
   * generated from media.audio.backend
   */
  enum class BackendLabel: uint16_t {
    eUnknown = 0,
    eAudiounit = 1,
    eAudiounitRust = 2,
    eAaudio = 3,
    eOpensl = 4,
    eWasapi = 5,
    eWinmm = 6,
    eAlsa = 7,
    eJack = 8,
    eOss = 9,
    ePulse = 10,
    ePulseRust = 11,
    eSndio = 12,
    eSunaudio = 13,
    e__Other__,
  };
  /**
   * The operating system audio backend (Migrated from the geckoview metric of the same name).
   */
  constexpr impl::Labeled<impl::CounterMetric, BackendLabel> backend(3469);

  /**
   * generated from media.audio.init_failure
   */
  enum class InitFailureLabel: uint16_t {
    eFirst = 0,
    eOther = 1,
    e__Other__,
  };
  /**
   * Failure occurs when initializing the audio stream. (Migrated from the geckoview metric of the same name).
   */
  constexpr impl::Labeled<impl::CounterMetric, InitFailureLabel> init_failure(3470);
}

namespace media_playback {
  /**
   * generated from media.playback.decode_error
   */
  struct DecodeErrorExtra {
    mozilla::Maybe<nsCString> decoderName;
    mozilla::Maybe<nsCString> errorName;
    mozilla::Maybe<bool> isHardwareAccelerated;
    mozilla::Maybe<nsCString> keySystem;
    mozilla::Maybe<nsCString> mimeType;

    std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
      nsTArray<nsCString> extraKeys;
      nsTArray<nsCString> extraValues;
      if (decoderName) {
        extraKeys.AppendElement()->AssignASCII("decoder_name");
        extraValues.EmplaceBack(decoderName.value());
      }
      if (errorName) {
        extraKeys.AppendElement()->AssignASCII("error_name");
        extraValues.EmplaceBack(errorName.value());
      }
      if (isHardwareAccelerated) {
        extraKeys.AppendElement()->AssignASCII("is_hardware_accelerated");
        extraValues.AppendElement()->AssignASCII(isHardwareAccelerated.value() ? "true" : "false");
      }
      if (keySystem) {
        extraKeys.AppendElement()->AssignASCII("key_system");
        extraValues.EmplaceBack(keySystem.value());
      }
      if (mimeType) {
        extraKeys.AppendElement()->AssignASCII("mime_type");
        extraValues.EmplaceBack(mimeType.value());
      }
      return std::make_tuple(std::move(extraKeys), std::move(extraValues));
    }
  };
  /**
   * Record the decode error details.
   */
  constexpr impl::EventMetric<DecodeErrorExtra> decode_error(3471);

  /**
   * generated from media.playback.device_hardware_decoder_support
   */
  enum class DeviceHardwareDecoderSupportLabel: uint16_t {
    eH264 = 0,
    eVp8 = 1,
    eVp9 = 2,
    eAv1 = 3,
    eHevc = 4,
    e__Other__,
  };
  /**
   * The results of hardware decoder support for different video codecs. True means that codec can be decoded by hardware on user's device.
   */
  constexpr impl::Labeled<impl::BooleanMetric, DeviceHardwareDecoderSupportLabel> device_hardware_decoder_support(3472);

  /**
   * generated from media.playback.first_frame_loaded
   */
  struct FirstFrameLoadedExtra {
    mozilla::Maybe<uint32_t> bufferingTime;
    mozilla::Maybe<nsCString> decoderName;
    mozilla::Maybe<uint32_t> firstFrameLoadedTime;
    mozilla::Maybe<bool> hlsDecoder;
    mozilla::Maybe<bool> isHardwareDecoding;
    mozilla::Maybe<bool> isHdr;
    mozilla::Maybe<nsCString> keySystem;
    mozilla::Maybe<uint32_t> metadataLoadedTime;
    mozilla::Maybe<nsCString> playbackType;
    mozilla::Maybe<nsCString> resolution;
    mozilla::Maybe<uint32_t> totalWaitingDataTime;
    mozilla::Maybe<nsCString> videoCodec;

    std::tuple<nsTArray<nsCString>, nsTArray<nsCString>> ToFfiExtra() const {
      nsTArray<nsCString> extraKeys;
      nsTArray<nsCString> extraValues;
      if (bufferingTime) {
        extraKeys.AppendElement()->AssignASCII("buffering_time");
        extraValues.EmplaceBack(nsPrintfCString("%d", bufferingTime.value()));
      }
      if (decoderName) {
        extraKeys.AppendElement()->AssignASCII("decoder_name");
        extraValues.EmplaceBack(decoderName.value());
      }
      if (firstFrameLoadedTime) {
        extraKeys.AppendElement()->AssignASCII("first_frame_loaded_time");
        extraValues.EmplaceBack(nsPrintfCString("%d", firstFrameLoadedTime.value()));
      }
      if (hlsDecoder) {
        extraKeys.AppendElement()->AssignASCII("hls_decoder");
        extraValues.AppendElement()->AssignASCII(hlsDecoder.value() ? "true" : "false");
      }
      if (isHardwareDecoding) {
        extraKeys.AppendElement()->AssignASCII("is_hardware_decoding");
        extraValues.AppendElement()->AssignASCII(isHardwareDecoding.value() ? "true" : "false");
      }
      if (isHdr) {
        extraKeys.AppendElement()->AssignASCII("is_hdr");
        extraValues.AppendElement()->AssignASCII(isHdr.value() ? "true" : "false");
      }
      if (keySystem) {
        extraKeys.AppendElement()->AssignASCII("key_system");
        extraValues.EmplaceBack(keySystem.value());
      }
      if (metadataLoadedTime) {
        extraKeys.AppendElement()->AssignASCII("metadata_loaded_time");
        extraValues.EmplaceBack(nsPrintfCString("%d", metadataLoadedTime.value()));
      }
      if (playbackType) {
        extraKeys.AppendElement()->AssignASCII("playback_type");
        extraValues.EmplaceBack(playbackType.value());
      }
      if (resolution) {
        extraKeys.AppendElement()->AssignASCII("resolution");
        extraValues.EmplaceBack(resolution.value());
      }
      if (totalWaitingDataTime) {
        extraKeys.AppendElement()->AssignASCII("total_waiting_data_time");
        extraValues.EmplaceBack(nsPrintfCString("%d", totalWaitingDataTime.value()));
      }
      if (videoCodec) {
        extraKeys.AppendElement()->AssignASCII("video_codec");
        extraValues.EmplaceBack(videoCodec.value());
      }
      return std::make_tuple(std::move(extraKeys), std::move(extraValues));
    }
  };
  /**
   * The time that the media pipeline takes to load the first video frame.
   */
  constexpr impl::EventMetric<FirstFrameLoadedExtra> first_frame_loaded(3473);

  /**
   * generated from media.playback.not_supported_video_per_mime_type
   * Count the amount of times where video playback is failed to start due to the mime type is not supported by Firefox. The result is accumulated per mime type, eg. video/hevc.
   */
  constexpr impl::Labeled<impl::CounterMetric, DynamicLabel> not_supported_video_per_mime_type(3474);
}

} // namespace mozilla::glean

#endif // mozilla_GleanDomMediaMetrics_h
